Subject: Re: exception vectors

From: Benjamin Herrenschmidt <[email-masked]>
Date: Mon, 31 Oct 2005 13:17:58 +1100

On Mon, 2005-10-31 at 01:35 +0100, Ingmar wrote:
> Hi all,
> 
> I am trying to overwrite the exception vector space of an ibook G4 :).
> 
> I have set up (for every exception) a small piece of code, that's a prefix of a
> handler to be called. My problem is, that writing the “small” chunks of code to
> the exception vector space gives no problem(so it seams) but writing all the
> pieces of code as one chunk gives a exception [dsi, dsisr 0x42000000], this
> indicates a store problem.
> 
> I have tried different modes of copying, mmu on/off, also chanced the WING bit,
> switched the exception prefix on.
> 
> I don't believe putting the exception vectors to there “place” one by one is the
> right way, in the Linux kernel the kernel get relocated and the code comes into
> place. I have taken this as an example, unfortunately to to result :(..
> 
>  - Am I overlooking something?
>  - Is the a “standard way” to overwrite the exception vector space of a powerpc?

Well, you typically do this with the MMU disabled and making sure you
don't take an exception while copying over them...

Ben.